unit ServData;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComServ, ComObj, VCLCom, StdVcl, BdeProv, ActiveX, DataBkr,
  prDAserverIB_TLB, DBTables, Provider, DBClient, Db;

type

  EInvalidSalary = class(Exception);

  TrdmDataAccessIB = class(TDataModule, IrdmDataAccessIB)
    EmpQuery: TQuery;
    EmpQueryEmpNo: TIntegerField;
    EmpQueryLastName: TStringField;
    EmpQueryFirstName: TStringField;
    EmpQueryPhoneExt: TStringField;
    EmpQueryHireDate: TDateTimeField;
    EmpQuerySalary: TFloatField;
    rsvrBusinessLogic: TRemoteServer;
    prvEmpQuery: TProvider;
    dbMain: TDatabase;
    procedure EmpQueryAfterOpen(DataSet: TDataSet);
    procedure rdmDataAccessIBCreate(Sender: TObject);
    procedure rdmDataAccessIBDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  protected
    function Get_EmpQuery: IProvider; safecall;
    function Get_SalaryBreak: Integer; safecall;
    function IsValidSalary(Salary: Integer): WordBool; safecall;
    function DBLogin(const UName, PWord: WideString): WordBool; safecall;
  end;

var
  rdmDataAccessIB: TrdmDataAccessIB;

implementation

uses ServMain;

{$R *.DFM}

function TrdmDataAccessIB.Get_EmpQuery: IProvider;
begin
  Result := EmpQuery.Provider;
end;

procedure TrdmDataAccessIB.EmpQueryAfterOpen(DataSet: TDataSet);
begin
  { Update the query counter }
  MainForm.IncQueryCount;
end;

procedure TrdmDataAccessIB.rdmDataAccessIBCreate(Sender: TObject);
begin
  { Update the client counter }
  MainForm.UpdateClientCount(1);
  {Invoke and import a business rules object}
  rsvrBusinessLogic.Connected := True;

  MainForm.UpdateBLCount(1);
end;

procedure TrdmDataAccessIB.rdmDataAccessIBDestroy(Sender: TObject);
begin
  { Update the client counter }
  MainForm.UpdateClientCount(-1);
  {Destroy the business rules object}

  MainForm.UpdateBLCount(-1);
end;

function TrdmDataAccessIB.Get_SalaryBreak: Integer;
begin
  Result := rsvrBusinessLogic.AppServer.Get_SalaryBreak;
  {Another opportunity to partition out some validation...}
end;

function TrdmDataAccessIB.IsValidSalary(Salary: Integer): WordBool;
begin
    Result := rsvrBusinessLogic.AppServer.IsValidSalary(Salary);
  {Insert whatever other data-specific logic desired to modify this
  result...}
end;

function TrdmDataAccessIB.DBLogin(const UName, PWord: WideString): WordBool;
var
  E : EDBEngineError;
begin
  Result := True;
  dbMain.Params.Add('Username=' + UName);
  dbMain.Params.Add('Password=' + PWord);
  try
    {try Connecting here; if failure, return false}
    dbMain.Connected := True;
  except
    On E:EDBEngineError do
    begin
      If Copy(E.Message, 1, 17) = ('Unknown database.') then
        Result := False;
    end; {On Exception}
  end; {try...except}
end;

initialization
  TComponentFactory.Create(ComServer, TrdmDataAccessIB,
    Class_rdmDataAccessIB, ciMultiInstance);
end.
