unit ServData;

{ This Datamodule is the CoClass for the IEmpServer interface.  It was
  created using the File | New | Remote Data Module menu option }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComServ, ComObj, VCLCom, StdVcl, DataBkr, Provider, BdeProv, Db, DBTables,
  ServPX_TLB, DBClient;

type

  TEmpServer = class(TDataModule, IEmpServer)
    EmpQuery: TQuery;
    rsvrBusinessLogic: TRemoteServer;
    procedure EmpQueryAfterOpen(DataSet: TDataSet);
    procedure EmpServerCreate(Sender: TObject);
    procedure EmpServerDestroy(Sender: TObject);
  protected
    function Get_EmpQuery: IProvider; safecall;
    function Get_SalaryBreak: Integer; safecall;
    function IsValidSalary(Salary: Integer): WordBool; safecall;
  end;

var
  EmpServer: TEmpServer;

implementation

{$R *.DFM}

uses ServMain;

{ This method was generated using the "export from datamodule" option on the
  local menu of any TQuery, Table, or TProvider component.  It returns the
  IProvider interface used by the client. }

function TEmpServer.Get_EmpQuery: IProvider;
begin
  Result := EmpQuery.Provider;
end;


{ This rest of this code just demonstrates how you might monitor client
  activity from the server.  None of this is required to develop an
  application server. }

procedure TEmpServer.EmpQueryAfterOpen(DataSet: TDataSet);
begin
  { Update the query counter }
  MainForm.IncQueryCount;
end;

procedure TEmpServer.EmpServerCreate(Sender: TObject);
begin
  { Update the client counter }
  MainForm.UpdateClientCount(1);
  rsvrBusinessLogic.Connected := True;
end;

procedure TEmpServer.EmpServerDestroy(Sender: TObject);
begin
  { Update the client counter }
  MainForm.UpdateClientCount(-1);
  rsvrBusinessLogic.Connected := False;
end;

function TEmpServer.Get_SalaryBreak: Integer;
begin
  Result := rsvrBusinessLogic.AppServer.Get_SalaryBreak;
  {Another opportunity to partition out some validation...}
end;

function TEmpServer.IsValidSalary(Salary: Integer): WordBool;
begin
  Result := rsvrBusinessLogic.AppServer.IsValidSalary(Salary);
  {Insert whatever other data-specific logic desired to modify this
  result...}
end;

initialization
 { This creates the class factory for us.  This code is generated automatically }
  TComponentFactory.Create(ComServer, TEmpServer, Class_EmpServer,
    ciMultiInstance);
end.
