unit fRAControls;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, RAComponentPanel, StdCtrls, ComCtrls,
  RARegAuto, RAButtons, RATreeView, Buttons, RAScrollMax, Mask, DBCtrls,
  RAScrollBar, RAImage, RACt, RACombo {$IFDEF RA_D4H}, ImgList{$ENDIF RA_D4H};

type
  TForm1 = class(TForm)
    PopupMenu1: TPopupMenu;
    Item1: TMenuItem;
    Item2: TMenuItem;
    Panel1: TPanel;
    RANoFrameButton1: TRANoFrameButton;
    RANoFrameButton2: TRANoFrameButton;
    Label1: TLabel;
    TabControl1: TTabControl;
    RAComponentPanel1: TRAComponentPanel;
    Memo1: TMemo;
    RegAuto2: TRegAuto;
    RACaptionButton1: TRACaptionButton;
    RACaptionButton2: TRACaptionButton;
    RACaptionButton3: TRACaptionButton;
    ImageList1: TImageList;
    Panel2: TPanel;
    RATreeComboBox1: TRAComboBox4Tree;
    RATreeView1: TRATreeView;
    RAColorButton1: TRAColorButton;
    RegAuto1: TRegAuto;
    RAScrollMax1: TRAScrollMax;
    RAScrollMaxBand1: TRAScrollMaxBand;
    Edit9: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Edit10: TEdit;
    RAScrollMaxBand2: TRAScrollMaxBand;
    Label13: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    Label14: TLabel;
    Edit13: TEdit;
    Label15: TLabel;
    RAScrollMaxBand3: TRAScrollMaxBand;
    Label16: TLabel;
    Edit14: TEdit;
    Edit15: TEdit;
    Label17: TLabel;
    Edit16: TEdit;
    Label18: TLabel;
    Label19: TLabel;
    RAImage1: TRAImage;
    Label20: TLabel;
    RAStatusBar1: TRAStatusBar;
    ProgressBar1: TProgressBar;
    RACombo1: TRACombo;
    RACheckBox1: TRACheckBox;
    Edit1: TEdit;
    procedure RAComponentPanel1Click(Sender: TObject; Button: Integer);
    procedure RAComponentPanel1DblClick(Sender: TObject; Button: Integer);
    procedure TabControl1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RACaptionButton1Click(Sender: TObject);
    procedure RANoFrameButton1Click(Sender: TObject);
    procedure RAColorButton1Click(Sender: TObject);
    procedure RAImage1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses RAUtils;

{$R *.DFM}

{$R RACtrl.dcr}
{$R RADB.dcr}
{$R RAInter.dcr}
{$R res.res}

procedure TForm1.RAComponentPanel1DblClick(Sender: TObject;
  Button: Integer);
begin
  Label1.Caption := 'Button  '+IntToStr(Button)+' double clicked';
end;

procedure TForm1.TabControl1Change(Sender: TObject);
const
  sRAControls = 'TRegAuto,TRegAutoGrid,TRAProgressForm,TRAEditor,'+
                'TRAHint,TRATreeView,TRAComboBox4Tree,'+
                'TRAScrollBar,TRAScrollBar95,TRACombo,TRAComponentPanel,'+
                'TRACaptionButton,TRANoFrameButton,TRAColorButton,TRAImage,'+
                'TRAScrollMax,TRAIProgram';
  sRADB       = 'TRASQLScript,TRADBTreeView,TRADBLookupTreeView,'+
                'TRADBLookupTreeViewCombo,TRAIField,TRADBRadioGroupS,TRADBTextS';
var
  Comps : string;
  S : string;
  i : integer;
begin
  case TabControl1.TabIndex of
    0 :
      begin
        Comps := sRAControls;
        RAComponentPanel1.ButtonCount := 17;
      end;
    1 :
      begin
        Comps := sRADB;
        RAComponentPanel1.ButtonCount := 7;
      end;
    else
      begin
        Comps := '';
      end;
  end;
  RAComponentPanel1.RecreateButtons;
  i := 0;
  S := RAUtils.SubStr(Comps, i, ',');
  while S <> '' do
  begin
    try
      RAComponentPanel1.Buttons[i].Glyph.LoadFromResourceName(hInstance, S);
      RAComponentPanel1.Buttons[i].Hint := S;
    except
    end;
    inc(i);
    S := RAUtils.SubStr(Comps, i, ',');
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.Title := Caption;
  RAScrollMax1.MouseClasses([TLabel]);
  TabControl1Change(nil);
end;

procedure TForm1.RAComponentPanel1Click(Sender: TObject; Button: Integer);
begin
  Label1.Caption := 'Button  '+IntToStr(Button)+' clicked';
  Memo1.Lines.Clear;
  if Button < 0 then exit;
  RegAuto2.ReadSection(RAComponentPanel1.Buttons[Button].Hint, Memo1.Lines);
end;

procedure TForm1.RACaptionButton1Click(Sender: TObject);
begin
  ShowMessage('RACaptionButton displays glyph');
end;

procedure TForm1.RANoFrameButton1Click(Sender: TObject);
begin
  ShowMessage('RANoFrameButton has not border');
end;

procedure TForm1.RAColorButton1Click(Sender: TObject);
begin
  ShowMessage('RAColorButton has color');
end;

procedure TForm1.RAImage1KeyPress(Sender: TObject; var Key: Char);
begin
  ShowMessage('Key "'+Key+'" pressed !');
end;

end.
