
{$INCLUDE RA.INC}

unit InterObj;

interface

uses SysUtils, Classes, Dialogs, Forms,
  RAIIntf, RAIImpl, RAIExpr;

type

  TInterObj = class(TIInterObject)
  private
    FSourcePath : string;
    sUnitSource : string;
  protected
    function SyncSetGetVar(var SGI : TSetGetInfo) : boolean; override;
  public
    Check : boolean;
    constructor Create;
    destructor Destroy; override;
    function GetUnitSource(UnitName : iString; var UnitSource, UnitFullName : iString) : boolean; override;
    property SearchPath : string write FSourcePath;
  end;

const
  eOk  = 0;
  eRem = 1;
  eNotEnd = 2;

implementation

uses RAUtils;

constructor TInterObj.Create;
var
  IObj : IIObject;
begin
  inherited Create;
  AppHandle := Application.Handle;
  CreateInterObject(IID_ISystem, IObj);
  SysObjs.Add(IObj);
  CreateInterObject(IID_ISysUtils, IObj);
  SysObjs.Add(IObj);
 {$IFDEF RAINTER_OLEAUTO}
  CreateInterObject(IID_IOleAuto, IObj);
  SysObjs.Add(IObj);
 {$ENDIF RAINTER_OLEAUTO}
end;

destructor TInterObj.Destroy;
begin
  inherited Destroy;
end;

function TInterObj.SyncSetGetVar(var SGI : TSetGetInfo) : boolean;
{var
  IList : TIList;
  i : integer;}
begin
//  Res.Empty;
  Result := inherited SyncSetGetVar(SGI);
(*
  if not Result and Get then begin
    Result := true;
    if ProcIs('DoubleList', 1, [ivObject]) then
      if Args[0].vObject is TIList then begin
        IList := Args[0].vObject as TIList;
        for i := 0 to IList.Count-1 do
          if IList[i].Typ = ivInteger then
            IList[i].vInteger := IList[i].vInteger * 2;
      end else InterErrorO(ieParams, 1)
    else if ProcIs('Handle', 0, [ivEmpty]) then
      Res.vInteger := Application.MainForm.Handle
    else Result := false;
  end;
*)  
end;

function TInterObj.GetUnitSource(UnitName : iString; var UnitSource, UnitFullName : iString) : boolean;
var
  S : TStringList;
  St : string;
  i : integer;
begin
  Result := false;
  i := 0;
  if UnitName = 'DivByZero' then i := i div i;
  if ExtractFilePath(UnitName) = '' then
    repeat
      St := GetSubStr(FSourcePath, i, ';');
      sResult := St+'\'+UnitName+'.itr';
      UnitFullName := iString(sResult);
      inc(i);
    until FileExists(UnitFullName) or (St = '')
  else UnitFullName := UnitName;
  if FileExists(UnitFullName) then begin
    S := TStringList.Create;
    try
      S.LoadFromFile(UnitFullName);
      Result := true;
    finally
      sUnitSource := S.Text;
      UnitSource := iString(sUnitSource);
    end;
    S.Free;
  end;
end;

end.
