unit fAbout;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TAboutBox = class(TForm)
    pnlAbout: TPanel;
    OKButton: TButton;
    timerRA: TTimer;
    imageRAFlic: TImage;
    Panel2: TPanel;
    imageRA: TImage;
    Label2: TLabel;
    Label4: TLabel;
    lblName: TLabel;
    lblProgr: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    procedure timerRATimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
    T : integer;
    procedure DrawShadowText(Lab : TLabel);
  public
    { Public declarations }
  end;


procedure AboutShowModal;

implementation

uses RAIExpr;

{$R *.DFM}

procedure AboutShowModal;
begin
  with TAboutBox.Create(Application) do
    try
      ShowModal;
    finally
      Free;
    end;
end;

procedure TAboutBox.timerRATimer(Sender: TObject);
const FrameNum : integer = 0;
begin
  {****  R&A ****}
  imageRA.Canvas.CopyRect(Rect(0, 0, 70, 70),
      imageRAFlic.Canvas,
      Rect(0, FrameNum * 70, 70, FrameNum * 70 + 70));
      inc(FrameNum);
    if FrameNum > 9 then FrameNum := 0;
  {####  R&A ####}
  if not Label1.Visible then begin
    inc(T);
    if T > 10 then begin
      Label1.Visible := true;
      Label3.Visible := true;
      pnlAbout.Refresh;
      timerRA.Interval := 100;
    end;  
  end;
end;

procedure TAboutBox.FormCreate(Sender: TObject);
begin
  Left := (Screen.Width - Width) div 2;
  Top := (Screen.Height - Height) div 3;
  Label3.Caption := 'version '+ IntToStr(Hi(InterVersion))+'.'
    + IntToStr(Lo(InterVersion));
  {  }
  imageRA.Canvas.CopyRect(Rect(0, 0, 70, 70),
      imageRAFlic.Canvas, Rect(0, 0, 70, 70));
end;

procedure TAboutBox.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
const
  KeyTeam : array[1..4] of char = ('T','E','A','M');
  Cur : integer = 1;
begin
  if ssAlt in Shift then
     if Key = word(KeyTeam[Cur]) then begin
       Key := 0; Shift := [];
       if Cur = 4 then begin
         Label1.Visible := false;
         Label3.Visible := false;
         Label1.Update;
         Label3.Update;
         T := 0;
         Paint;
         Cur := 1;
       end else inc(Cur);
     end
  else Cur := 1;
end;

type TMyPanel = class(TPanel) end;

procedure TAboutBox.DrawShadowText(Lab : TLabel);
var
  RText, RShadow: TRect;
begin
  RText := Lab.BoundsRect;
  RShadow := RText;
  with TMyPanel(pnlAbout).Canvas do begin
  Brush.Style := bsClear;
  Font := Lab.Font;
  Font.Color := clBtnHighlight;
  OffsetRect(RText, 1, 1);
  DrawText(Handle, PChar(Lab.Caption), Length(Lab.Caption), RShadow, 0);
  Font.Color := Lab.Font.Color;
  DrawText(Handle, PChar(Lab.Caption), Length(Lab.Caption), RText, 0);
  end;
end;

procedure TAboutBox.FormPaint(Sender: TObject);
begin
  if not Label1.Visible then begin
    DrawShadowText(lblProgr);
    DrawShadowText(lblName);
  end;  
end;





end.

