unit fBreakpoints;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RARegAuto, StdCtrls, ComCtrls, Menus;

type
  TBreakpoints = class(TForm)
    Label1: TLabel;
    RegAuto: TRegAuto;
    lvBreakPoints: TListView;
    pmBreakPoints: TPopupMenu;
    miProp: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure lvBreakPointsDblClick(Sender: TObject);
    procedure lvBreakPointsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure miPropClick(Sender: TObject);
  private
    { Private declarations }
   XX, YY : integer;
  public
    { Public declarations }
    procedure UpdateBreakPoints;
  end;

var
  Breakpoints: TBreakpoints;

implementation
uses fMain, fEditor, fBreakPointProp;

{$R *.DFM}

procedure TBreakpoints.UpdateBreakPoints;
var
  i : integer;
  ListItem : TListItem;
begin
  lvBreakPoints.Items.Clear;
  with Main.InterObj.IDebugObject do
    for i := 0 to BreakPoints.Count-1 do with BreakPoints[i] do begin
      ListItem := lvBreakPoints.Items.Add;
      ListItem.Caption := UnitName;
      ListItem.SubItems.Add(IntToStr(PosBeg)+'-'+IntToStr(PosEnd)); {}
      ListItem.SubItems.Add(Condition); {}
      ListItem.SubItems.Add(IntToStr(Pass)); {}
    end;
end;

procedure TBreakpoints.FormCreate(Sender: TObject);
begin
  with lvBreakPoints do begin
    Columns.Clear;
    with Columns.Add do begin
      Caption := 'Unit';
      Width := 100;
    end;
    with Columns.Add do begin
      Caption := 'Position';
      Width := 60;
    end;
    with Columns.Add do begin
      Caption := 'Condition';
      Width := 60;
    end;
    with Columns.Add do begin
      Caption := 'Pass count';
      Width := 60;
    end;
  end;
end;

procedure TBreakpoints.lvBreakPointsDblClick(Sender: TObject);
var
  ListItem : TListItem;
begin
  ListItem := lvBreakPoints.GetItemAt(XX, YY);
  if ListItem <> nil then
    Editor.ShowBreakPoint(ListItem.Index);
end;

procedure TBreakpoints.lvBreakPointsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  XX := X; YY := Y;
end;

procedure TBreakpoints.miPropClick(Sender: TObject);
var
  ListItem : TListItem;
begin
  ListItem := lvBreakPoints.GetItemAt(XX, YY);
  if ListItem <> nil then begin
    fBreakPointProp.ShowModal(ListItem.Index);
    UpdateBreakPoints;
  end;  
end;

end.
