unit fCallStack;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RARegAuto, StdCtrls,
  RAIIntf;

type
  TCallStack = class(TForm)
    RegAuto: TRegAuto;
    lbCallStack: TListBox;
    procedure lbCallStackDblClick(Sender: TObject);
    procedure lbCallStackMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    YY : integer;
  public
    procedure DebugProc;
    procedure DebugDone;
  end;

var
  CallStack: TCallStack;

implementation
uses fMain;

{$R *.DFM}

procedure TCallStack.DebugProc;
var
  i, iArg : integer;
  S, S1 : string;
  CS : TCallStackItem;
begin
  lbCallStack.Clear;
  for i := 0 to Main.InterObj.IDebugObject.CallStack.Count -1 do begin
    CS := Main.InterObj.IDebugObject.CallStack[i];
    if CS.FuncName[0] <> #0 then begin
      S1 := CS.FuncName; // 
      if CS.Args.Count > 0 then begin
        S := '(';
        for iArg := 0 to CS.Args.Count-1 do begin
          S1 := S1 + S + CS.Args[iArg].Str;
          S := ', ';
        end;
        S1 := S1 +')';
      end;
      lbCallStack.Items.AddObject(S1, TObject(i));
    end;  
  end;
end;

procedure TCallStack.DebugDone;
begin
  lbCallStack.Clear;
end;

procedure TCallStack.lbCallStackDblClick(Sender: TObject);
begin
  YY := lbCallStack.ItemAtPos(Point(0, YY), false);
  if YY <> -1 then
    Main.ShowCallStackItem(integer(lbCallStack.Items.Objects[YY]));
end;

procedure TCallStack.lbCallStackMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  YY := Y;
end;

end.
