unit fConsole;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, RARegAuto, Menus;

type
  TConsole = class(TForm)
    memMess: TMemo;
    Panel1: TPanel;
    lblTime: TLabel;
    RegAuto: TRegAuto;
    Timer1: TTimer;
    lblState: TLabel;
    pmOutput: TPopupMenu;
    miClear: TMenuItem;
    lblInfo: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure miClearClick(Sender: TObject);
    procedure memMessKeyPress(Sender: TObject; var Key: Char);
    procedure memMessKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    BegTime : longint;
    procedure SetStatus(S : string);
    function GetStatus : string;
  public
    { Public declarations }
    procedure TimerStart;
    procedure TimerStop;
    procedure MessAdd(S : string);
    property Status : string read GetStatus write SetStatus;
  end;

var
  Console: TConsole;

implementation

uses fMain, RAIExpr, RAIIntf, fEditor;

{$R *.DFM}

procedure TConsole.Timer1Timer(Sender: TObject);
var
  Tm : integer;
begin
  Tm := integer(GetTickCount) - BegTime;
  lblTime.Caption := TimeToStr(TimeStampToDateTime(MSecsToTimeStamp(Tm)));
  Tm := (Tm mod 1000);
  if Tm < 10 then
    lblTime.Caption := lblTime.Caption +':0'+IntToStr(Tm)
  else
    lblTime.Caption := lblTime.Caption +':'+IntToStr(Tm);
  lblTime.Caption := Copy(lblTime.Caption, 1, length(lblTime.Caption)-1);
 {$IFDEF DEBUG}
  lblInfo.Caption := IntToStr(GlobalObjCount) +' : '+ IntToStr(GlobalRefCount)
 {$ENDIF}
end;

procedure TConsole.TimerStart;
const Ras : integer = 0;
begin
  BegTime := GetTickCount;
  Timer1.Enabled := true;
  inc(Ras);
  MessAdd('--------- '+IntToStr(Ras)+' ---------');
end;

procedure TConsole.TimerStop;
begin
  Timer1.Enabled := false;
  Timer1Timer(self);
end;

procedure TConsole.SetStatus(S : string);
begin
  lblState.Caption := S;
end;

function TConsole.GetStatus : string;
begin
  Result := lblState.Caption;
end;

procedure TConsole.MessAdd(S : string);
begin
  memMess.Lines.Add(S);
end;

procedure TConsole.miClearClick(Sender: TObject);
begin
  memMess.Clear;
end;

procedure TConsole.memMessKeyPress(Sender: TObject; var Key: Char);
var
  V,S : string;
begin
  if Key = #13 then begin
    S := memMess.Lines[memMess.Lines.Count-1];
    if Main.InterObj.IDebugObject.EvaluateModify(S, V, dfAll) then
      memMess.Text := memMess.Text+#13+#10+V
    else begin
      Main.InterObj.IDebugObject.Reset;
      Main.AddToInter(S);
    end;
    memMess.SelStart := Length(memMess.Text);
  end;
end;

procedure TConsole.memMessKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//  if Key = VK_UP then Key := 0;
end;


end.
