unit fWatches;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RARegAuto, StdCtrls, ComCtrls, Menus;

type
  TWatches = class(TForm)
    RegAuto: TRegAuto;
    pmWatches: TPopupMenu;
    miAdd: TMenuItem;
    miDelete: TMenuItem;
    miChange: TMenuItem;
    lvWatches: TListView;
    procedure miAddClick(Sender: TObject);
    procedure miDeleteClick(Sender: TObject);
    procedure RegAutoAfterLoad(Sender: TObject);
    procedure RegAutoAfterSave(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lvWatchesEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DebugProc;
    procedure DebugDone;
  end;

var
  Watches: TWatches;

implementation

uses fMain, RAIIntf;

{$R *.DFM}

procedure TWatches.lvWatchesEdited(Sender: TObject; Item: TListItem; var S: String);
var
  Value : string;
begin
  Main.InterObj.IDebugObject.EvaluateModify(Item.Caption, Value, dfEvaluate);
  Item.SubItems[0] := Value;
  Item.Update;
end;

procedure TWatches.DebugProc;
var
  i : integer;
  Value : string;
begin
  if not Visible then exit;
  for i := 0 to lvWatches.Items.Count -1 do with lvWatches.Items[i] do begin
    Main.InterObj.IDebugObject.EvaluateModify(Caption, Value, dfEvaluate);
    SubItems[0] := Value;
    Update;
  end;
end;

procedure TWatches.DebugDone;
var
  i : integer;
begin
  for i := 0 to lvWatches.Items.Count -1 do with lvWatches.Items[i] do begin
    SubItems[0] := '[value not accesible]';
    Update;
  end;
end;

procedure TWatches.miAddClick(Sender: TObject);
var
  ListItem : TListItem;
begin
  ListItem := lvWatches.Items.Add;
  ListItem.Caption := 'i';
  ListItem.SubItems.Add('');
end;

procedure TWatches.miDeleteClick(Sender: TObject);
begin
  if lvWatches.Selected <> nil then
    if Sender = miDelete then lvWatches.Selected.Delete
    else if Sender = miChange then lvWatches.Selected.EditCaption;
end;

procedure TWatches.RegAutoAfterLoad(Sender: TObject);
var
  i        : integer;
  ListItem : TListItem;
  Value : string;
begin
  for i := 0 to RegAuto.ReadInteger('Watches\Watches', 'Count', 0)-1 do begin
    ListItem := lvWatches.Items.Add;
    ListItem.Caption := RegAuto.ReadString('Watches\Watches', 'Watche'+IntToStr(i), 'i');
    ListItem.SubItems.Add(Value);
  end;
  DebugProc;
end;

procedure TWatches.RegAutoAfterSave(Sender: TObject);
var i : integer;
begin
  RegAuto.EraseSection('Watches\Watches');
  RegAuto.WriteInteger('Watches\Watches', 'Count', lvWatches.Items.Count);
  for i := 0 to lvWatches.Items.Count-1 do
    RegAuto.WriteString('Watches\Watches', 'Watche'+IntToStr(i), lvWatches.Items[i].Caption);
end;

procedure TWatches.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RegAuto.Save;
end;

procedure TWatches.FormCreate(Sender: TObject);
begin
  with lvWatches do begin
    Columns.Clear;
    with Columns.Add do begin
      Caption := 'Expression';
      Width := 100;
    end;
    with Columns.Add do begin
      Caption := 'Value';
      Width := 60;
    end;
  end;
end;

end.

