{***************************************************************}
{                                                               }
{  FormulaLib Entry Editor for Delphi ( 16 & 32-bit )           }
{                                                               }
{  Copyright (c) 1996, 1997  Dimak & Vlad.S                     }
{                                                               }
{  e-mail:  dimak@uniyar.ac.ru  &  vlads@uniyar.ac.ru           }
{                                                               }
{***************************************************************}

unit FCLiBEd;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils,
  FCLib, FCUtils;

{ TFormulaEditor - dialog window which allows }
{ edit user function name and source          }
type
  TFormulaEditor = class(TForm)
    Bevel: TBevel;
    NameEd: TEdit;
    NameLabel: TLabel;
    SrcLabel: TLabel;
    SourceEd: TEdit;
    OkBtn: TButton;
    CancelBtn: TButton;
    procedure OKBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    FIndex: Integer;        { number of item in the function library  }
    List: TFunctionList;    { function library }
  public
    { edit item AIndex from library AList }
    procedure Edit(AList: TFunctionList; AIndex: Integer; ASource: string);
  end;

var
  FormulaEditor: TFormulaEditor;

implementation

{$R *.DFM}

procedure TFormulaEditor.Edit;
begin
  { store number of item and library }
  FIndex := AIndex;
  List := AList;
  if FIndex < 0
    then begin
     { if FIndex < 0 then it is a new formula }
      NameEd.Text := '';
      SourceEd.Text := ASource;
    end
    else begin
      { else get function's name and source from the library}
      NameEd.Text := List.Names[FIndex];
      SourceEd.Text := List.Sources[FIndex];
    end;
  { show dialog }
  ShowModal;
end;

procedure TFormulaEditor.OKBtnClick(Sender: TObject);
var
  Temp: string;
begin
  { add formula to the library }
  if FIndex < 0
    then FCCheck(List.Add(NameEd.Text, SourceEd.Text))
  { update name and source }
    else begin
      Temp := List.Names[FIndex];
      List.Names[FIndex] := NameEd.Text;
      try
        List.Sources[FIndex] := SourceEd.Text;
      except
        List.Names[FIndex] := Temp;
        raise;
      end;
    end;
  { close dialog }
  Close;
end;

procedure TFormulaEditor.FormActivate(Sender: TObject);
begin
  NameEd.SetFocus;
end;

end.
