{***************************************************************}
{                                                               }
{  Formula Compiler Pack for Delphi ( 16 & 32-bit ) ver 3.0     }
{                                                               }
{  Copyright (c) 1996, 1997  Dimak & Vlad.S                     }
{                                                               }
{  e-mail:  dimak@uniyar.ac.ru  &  vlads@uniyar.ac.ru           }
{                                                               }
{***************************************************************}

unit FCReg;

interface

uses Classes, DsgnIntf, SysUtils, Forms, FCLib, FC;

procedure Register;

type
  TFormulaLibEditor = class(TComponentEditor)
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

implementation

procedure Register;
begin
  { Register components }
  RegisterComponents('Math', [TFormulaLib,
                              TFormulaCompilerE, TFormulaCompilerD]);
  { Register property editor for TFormulaLib }
  RegisterComponentEditor(TFormulaLib, TFormulaLibEditor);
end;

{ TFormulaLibEditor }
function TFormulaLibEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

function TFormulaLibEditor.GetVerb(Index: Integer): string;
begin
  if Index = 0
    then Result := 'Function editor'
    else Result := 'Alias editor';
end;

procedure TFormulaLibEditor.ExecuteVerb(Index: Integer);
begin
  if TFormulaLib(Component).Edit(Index) then Designer.Modified;
end;

end.
