unit Fig1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
    String10 = String[10];
    TBinaryNode = class(TObject)
        public
            node_value              : String10;
            left_child, right_child : TBinaryNode;
    end;

  TFig1TreeForm = class(TForm)
    cmdBuildTree: TButton;
    procedure cmdBuildTreeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Fig1TreeForm: TFig1TreeForm;

implementation

{$R *.DFM}

var
    root : TBinaryNode;

// Build a tree like the one in Figure 1.
procedure BuildFig1Tree;
var
    child : TBinaryNode;
begin
    // Create the root node A.
    root := TBinaryNode.Create;
    root.node_value := 'A';

    // Create node B.
    child := TBinaryNode.Create;
    child.node_value := 'B';
    root.left_child := child;

    // Create node C.
    child := TBinaryNode.Create;
    child.node_value := 'C';
    child.left_child := nil;
    child.right_child := nil;
    root.right_child := child;

    // Create node D.
    child := TBinaryNode.Create;
    child.node_value := 'D';
    child.left_child := nil;
    child.right_child := nil;
    root.left_child.left_child := child;

    // Create node E.
    child := TBinaryNode.Create;
    child.node_value := 'E';
    child.left_child := nil;
    child.right_child := nil;
    root.left_child.right_child := child;
end;

procedure TFig1TreeForm.cmdBuildTreeClick(Sender: TObject);
begin
    BuildFig1Tree;

    // Verify that the D and E nodes are in their
    // correct positions.
    ShowMessage(root.left_child.left_child.node_value);
    ShowMessage(root.left_child.right_child.node_value);
end;

end.
