{UTAnothe.pas}
{$X+ extended syntax}
unit Utanothe;

INTERFACE
uses
  Classes;

type
  TAnother = class
    constructor Create(const aString: string);
    constructor Clone(const aTAnother: TAnother);
    constructor Get(S: TStream);
    constructor Read(var f: Textfile);

    destructor Destroy; override;

    procedure Copy(const aTAnother: TAnother);
    function Equals(const aTAnother: TAnother): boolean;
    procedure Put(S: TStream);
    procedure Write(var f: Textfile);

    function GetS: string;
    function SetS(const aString: string): string;

  private
    s: string;
  end;  {TAnother}

{]====================================================[}

                     IMPLEMENTATION

uses
  SysUtils;


constructor TAnother.Create(const aString: string);
begin
	s := aString;
end;  {Create}

constructor TAnother.Clone(const aTAnother: TAnother);
begin
  inherited Create;
  s := aTAnother.s;
end;  {Clone}

constructor TAnother.Get(S: TStream);
begin
  inherited Create;
  S.Read(s,sizeof(s));
end;  {Get}

constructor TAnother.Read(var f: Textfile);
begin
  // to be added
end;  {Read}

destructor TAnother.Destroy;  {override}
begin
  inherited Destroy;
end;  {Destroy}

procedure TAnother.Copy(const aTAnother: TAnother);
begin
  if Self = aTAnother then Exit;  {don't clobber self}
  s := aTAnother.s;
end;  {Copy}

function TAnother.Equals(const aTAnother: TAnother): boolean;
begin
  Result := true;
  if Self = aTAnother then Exit;  {saves time?}
  Result := Result and (s = aTAnother.s);
end;  {Equals}

procedure TAnother.Put(S: TStream);
begin
  S.Write(s,sizeof(s));
end;  {Put}

procedure TAnother.Write(var f: Textfile);
begin
end;  {Write}

function TAnother.GetS: string;
begin
  Result := s;
end; {GetS}

function TAnother.SetS(const aString: string): string;
begin
  Result := s;
  s := aString;
end; {SetS}

{initialization}
{finalization}
end. {UTAnothe.pas}
