{UTBase.pas}
{$X+ extended syntax}
unit Utbase;

INTERFACE
uses
  Classes;

type
  TBase = class
    constructor Create(const aChar:char);
    constructor Clone(const aTBase: TBase);
    constructor Get(S: TStream);
    constructor Read(var f: Textfile);

    destructor Destroy; override;

    procedure Copy(const aTBase: TBase);
    function Equals(const aTBase: TBase): boolean;
    procedure Put(S: TStream);
    procedure Write(var f: Textfile);

    function GetC: char;
    function SetC(const aChar: char): char;

  private
    c: char;
  end;  {TBase}

{]====================================================[}

                     IMPLEMENTATION

uses
  SysUtils;

constructor TBase.Create(const aChar:char);
begin
  c := aChar;
end;  {Create}

constructor TBase.Clone(const aTBase: TBase);
begin
  inherited Create;
  c := aTBase.c;
end;  {Clone}

constructor TBase.Get(S: TStream);
begin
  inherited Create;
  S.Read(c,sizeof(c));
end;  {Get}

constructor TBase.Read(var f: Textfile);
begin
  // to be added
end;  {Read}

destructor TBase.Destroy;  {override}
begin
  inherited Destroy;
end;  {Destroy}

procedure TBase.Copy(const aTBase: TBase);
begin
  if Self = aTBase then Exit;  {don't clobber self}
  c := aTBase.c;
end;  {Copy}

function TBase.Equals(const aTBase: TBase): boolean;
begin
  Result := true;
  if Self = aTBase then Exit;  {saves time?}
  Result := Result and (c = aTBase.c);
end;  {Equals}

procedure TBase.Put(S: TStream);
begin
  S.Write(c,sizeof(c));
end;  {Put}

procedure TBase.Write(var f: Textfile);
begin
end;  {Write}

function TBase.GetC: char;
begin
  Result := c;
end; {GetC}

function TBase.SetC(const aChar: char): char;
begin
  Result := c;
  c := aChar;
end; {SetC}

{initialization}
{finalization}
end. {UTBase.pas}
