{UTDerive.pas}
{$X+ extended syntax}
unit Utderive;

INTERFACE
uses
	Classes,
	UTBase,
	UTAnoKid;

type
	TDerived = class( TBase )
		constructor Create(const aChar: Char; const anAK: TAnotherKid);
		constructor Clone(const aTDerived: TDerived);
		constructor Get(S: TStream);
		constructor Read(var f: Textfile);

		destructor Destroy; override;

		procedure Copy(const aTDerived: TDerived);
		function Equals(const aTDerived: TDerived): boolean;
		procedure Put(S: TStream);
		procedure Write(var f: Textfile);

		function GetAK: TAnotherKid;
		function SetAK(const aTAnotherKid: TAnotherKid): TAnotherKid;

	private
		AK: TAnotherKid;
	end;  {TDerived}

{]====================================================[}

										 IMPLEMENTATION

uses
	SysUtils;


constructor TDerived.Create(const aChar: Char; const anAK: TAnotherKid);
begin
	inherited Create(aChar);
	AK := TAnotherKid.Create('some kind of string',Pi);
end;  {Create}

constructor TDerived.Clone(const aTDerived: TDerived);
begin
	inherited Clone(aTDerived);
	AK := TAnotherKid.Clone(aTDerived.AK);
end;  {Clone}

constructor TDerived.Get(S: TStream);
begin
	inherited Get(S);
	AK := TAnotherKid.Get(S);
end;  {Get}

constructor TDerived.Read(var f: Textfile);
begin
	// to be added
end;  {Read}

destructor TDerived.Destroy;  {override}
begin
	AK.Free;
	AK := nil;
	inherited Destroy;
end;  {Destroy}

procedure TDerived.Copy(const aTDerived: TDerived);
begin
	if Self = aTDerived then Exit;  {don't clobber self}
	inherited Copy(aTDerived);
	AK.Copy(aTDerived.AK);
end;  {Copy}

function TDerived.Equals(const aTDerived: TDerived): boolean;
begin
	Result := true;
	if Self = aTDerived then Exit;  {saves time?}
	Result := Result and TBase(Self).Equals(TBase(aTDerived));
	Result := Result and (AK.Equals(aTDerived.AK));
end;  {Equals}

procedure TDerived.Put(S: TStream);
begin
	inherited Put(S);
	AK.Put(S);
end;  {Put}

procedure TDerived.Write(var f: Textfile);
begin
end;  {Write}

function TDerived.GetAK: TAnotherKid;
begin
	Result := AK;
end; {GetAK}

function TDerived.SetAK(const aTAnotherKid: TAnotherKid): TAnotherKid;
begin
	Result := AK;
	AK := aTAnotherKid;
end; {SetAK}

{initialization}
{finalization}
end. {UTDerive.pas}
