unit WSAErr;
interface
Uses
 Windows, WinSock2;

function WSAErrorMsg : String;

implementation


function WSAErrorMsg : String;
begin
 case WSAGetLastError of
  WSAEINTR           : Result := 'Interrupted system call';{WSAEINTR}
  WSAEBADF           : Result := 'Bad file number'; {WSAEBADF}
  WSAEACCES          : Result := 'Permission denied'; {WSAEINTR}
  WSAEFAULT          : Result := 'Bad address';{WSAEFAULT}
  WSAEINVAL          : Result := 'Invalid argument';{WSAEINVAL}
  WSAEMFILE          : Result := 'Too many open files';{WSAEMFILE}
  WSAEWOULDBLOCK     : Result := 'Operation would block';{WSAEWOULDBLOCK}
  WSAEINPROGRESS     : Result := 'Operation now in progress';{WSAEINPROGRESS}
  WSAEALREADY        : Result := 'Operation already in progress';{WSAEALREADY}
  WSAENOTSOCK        : Result := 'Socket operation on nonsocket';{WSAENOTSOCK}
  WSAEDESTADDRREQ    : Result := 'Destination address required';{WSAEDESTADDRREQ}
  WSAEMSGSIZE        : Result := 'Message too long';{WSAEMSGSIZE}
  WSAEPROTOTYPE      : Result := 'Protocol wrong type for socket';{WSAEPROTOTYPE}
  WSAENOPROTOOPT     : Result := 'Protocol not available';{WSAENOPROTOOPT}
  WSAEPROTONOSUPPORT : Result := 'Protocol not supported';{WSAEPROTONOSUPPORT}
  WSAESOCKTNOSUPPORT : Result := 'Socket not supported';{WSAESOCKTNOSUPPORT}
  WSAEOPNOTSUPP      : Result := 'Operation not supported on socket';{WSAEOPNOTSUPP}
  WSAEPFNOSUPPORT    : Result := 'Protocol family not supported';{WSAEPFNOSUPPORT}
  WSAEAFNOSUPPORT    : Result := 'Address family not supported';{WSAEAFNOSUPPORT}
  WSAEADDRINUSE      : Result := 'Address already in use';{WSAEADDRINUSE}
  WSAEADDRNOTAVAIL   : Result := 'Can''t assign requested address';{WSAEADDRNOTAVAIL}
  WSAENETDOWN        : Result := 'Network is down';{WSAENETDOWN}
  WSAENETUNREACH     : Result := 'Network is unreachable';{WSAENETUNREACH}
  WSAENETRESET       : Result := 'Network dropped connection on reset';{WSAENETRESET}
  WSAECONNABORTED    : Result := 'Software caused connection abort';{WSAECONNABORTED}
  WSAECONNRESET      : Result := 'Connection reset by peer';{WSAECONNRESET}
  WSAENOBUFS         : Result := 'No buffer space available';{WSAENOBUFS}
  WSAEISCONN         : Result := 'Socket is already connected';{WSAEISCONN}
  WSAENOTCONN        : Result := 'Socket is not connected';{WSAENOTCONN}
  WSAESHUTDOWN       : Result := 'Can''t send after socket shutdown';{WSAESHUTDOWN}
  WSAETOOMANYREFS    : Result := 'Too many references:can''t splice';{WSAETOOMANYREFS}
  WSAETIMEDOUT       : Result := 'Connection timed out';{WSAETIMEDOUT}
  WSAECONNREFUSED    : Result := 'Connection refused';{WSAECONNREFUSED}
  WSAELOOP           : Result := 'Too many levels of symbolic links';{WSAELOOP}
  WSAENAMETOOLONG    : Result := 'File name is too long';{WSAENAMETOOLONG}
  WSAEHOSTDOWN       : Result := 'Host is down';{WSAEHOSTDOWN}
  WSAEHOSTUNREACH    : Result := 'No route to host';{WSAEHOSTUNREACH}
  WSAENOTEMPTY       : Result := 'Directory is not empty';{WSAENOTEMPT}
  WSAEPROCLIM        : Result := 'Too many processes';{WSAEPROCLIM}
  WSAEUSERS          : Result := 'Too many users';{WSAEUSERS}
  WSAEDQUOT          : Result := 'Disk quota exceeded';{WSAEDQUOT}
  WSAESTALE          : Result := 'Stale NFS file handle';{WSAESTALE}
  WSAEREMOTE         : Result := 'Too many levels of remote in path';{WSAEREMOTE}
  WSASYSNOTREADY     : Result := 'Network subsystem is unusable';{WSASYSNOTREADY}
  WSAVERNOTSUPPORTED : Result := 'Winsock DLL cannot support this application';{WSAVERNOTSUPPORTED}
  WSANOTINITIALISED  : Result := 'Winsock not initialized';{WSANOTINITIALISED}
  WSAHOST_NOT_FOUND  : Result := 'Host not found';{WSAHOST NOT FOUND}
  WSATRY_AGAIN       : Result := 'Non authoritative - host not found';{WSATRY_AGAIN}
  WSANO_RECOVERY     : Result := 'Non recoverable error';
  WSANO_DATA         : Result := 'Valid name, no data record of requested type'
  else Result := 'Not a Winsock error';
 end;
end;



end.
 