unit Report1;

{
  Sample report - customer details.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RepBase, Quickrep, DB, DBTables, StdCtrls, ExtCtrls;

type
  TqrfReport1 = class(TqrfBase)
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRLabel3: TQRLabel;
    QRLabel4: TQRLabel;
    QRLabel5: TQRLabel;
    QRLabel6: TQRLabel;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    QRDBText4: TQRDBText;
    QRDBText5: TQRDBText;
    QRDBText6: TQRDBText;
    qryReportCustNo: TFloatField;
    qryReportCompany: TStringField;
    qryReportCity: TStringField;
    qryReportState: TStringField;
    qryReportZip: TStringField;
    qryReportLastInvoiceDate: TDateTimeField;
  protected
    procedure SetParams(slsParams: TStrings); override;
  end;

implementation

{$R *.DFM}

uses
  RepParam;

{ Set up query from parameters }
procedure TqrfReport1.SetParams(slsParams: TStrings);
var
  sConnect: String;
  sSelection: String;

  procedure AddSelection(sFilter, sPlain: String);
  begin
    qryReport.SQL.Add(sConnect + sFilter);
    if sPlain <> '' then
      sSelection := sSelection + ' ' + sConnect + sPlain;
    sConnect := '  and ';
  end;

begin
  inherited SetParams(slsParams);
  with qryReport do
  begin
    { Build selection criteria }
    sConnect := 'where ';
    sSelection := '';
    if slsParams.Values[sFilter] <> '' then
      AddSelection(slsParams.Values[sFilter], '');
    if slsParams.Values[sCustomer] <> '' then
      AddSelection('CustNo = ' + slsParams.Values[sCustomer],
        'Customer is ' + slsParams.Values[sCustomer]);
    if slsParams.Values[sState] <> '' then
      AddSelection('State = ''' + slsParams.Values[sState] + '''',
        'State is ' + slsParams.Values[sState]);
    if slsParams.Values[sDate] <> '' then
      AddSelection('LastInvoiceDate >= ''' + slsParams.Values[sDate] + '''',
        'Last Invoiced On or After ' + slsParams.Values[sDate]);
    SQL.Add('order by ' + slsParams.Values[sSortBy]);
    Open;
    SetSelection(Copy(sSelection, 8, Length(sSelection) - 7),  { Remove initial connector }
      slsParams.Values[sSortDesc]);
  end;
end;

initialization
  { Tell application about this form }
  RegisterClass(TqrfReport1);
end.
