unit Report2;

{
  Sample report - order details.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RepBase, QuickRpt, DB, DBTables, StdCtrls, ExtCtrls, Qrctrls;

type
  TqrfReport2 = class(TqrfBase)
    QRLabel1: TQRLabel;
    QRLabel2: TQRLabel;
    QRLabel3: TQRLabel;
    QRLabel4: TQRLabel;
    QRLabel5: TQRLabel;
    QRLabel6: TQRLabel;
    QRLabel7: TQRLabel;
    QRDBText1: TQRDBText;
    QRDBText2: TQRDBText;
    QRDBText3: TQRDBText;
    QRDBText4: TQRDBText;
    QRDBText5: TQRDBText;
    QRDBText6: TQRDBText;
    QRDBText7: TQRDBText;
    qryReportOrderNo: TFloatField;
    qryReportCustNo: TFloatField;
    qryReportSaleDate: TDateTimeField;
    qryReportPaymentMethod: TStringField;
    qryReportItemsTotal: TCurrencyField;
    qryReportAmountPaid: TCurrencyField;
    qryReportCompany: TStringField;
    QRShape3: TQRShape;
    QRExpr1: TQRExpr;
    QRExpr2: TQRExpr;
    procedure qrbSummaryBeforePrint(Sender: TQRCustomBand;
      var PrintBand: Boolean);
  protected
    procedure SetParams(slsParams: TStrings); override;
  end;

implementation

{$R *.DFM}

uses
  RepParam;

{ Set up query from parameters }
procedure TqrfReport2.SetParams(slsParams: TStrings);
var
  sConnect, sDates, sSelection: String;

  procedure AddSelection(sFilter, sPlain: String);
  begin
    qryReport.SQL.Add(sConnect + sFilter);
    if sPlain <> '' then
      sSelection := sSelection + ' ' + sConnect + sPlain;
    sConnect := '  and ';
  end;

begin
  inherited SetParams(slsParams);
  with qryReport do
  begin
    { Build selection criteria }
    sConnect := '  and ';
    sSelection := '';
    sDates := '';
    if slsParams.Values[sFilter] <> '' then
      AddSelection(slsParams.Values[sFilter], '');
    if slsParams.Values[sCustomer] <> '' then
      AddSelection('CustNo = ' + slsParams.Values[sCustomer],
        'Customer is ' + slsParams.Values[sCustomer]);
    if slsParams.Values[sState] <> '' then
      AddSelection('State = ''' + slsParams.Values[sState] + '''',
        'State is ' + slsParams.Values[sState]);
    if slsParams.Values[sDateFrom] <> '' then
      AddSelection('SaleDate >= ''' + slsParams.Values[sDateFrom] + '''', '');
    if slsParams.Values[sDateTo] <> '' then
      AddSelection('SaleDate <= ''' + slsParams.Values[sDateTo] + '''', '');
    if (slsParams.Values[sDateFrom] <> '') and
        (slsParams.Values[sDateTo] <> '') then
      sDates := 'between ' + slsParams.Values[sDateFrom] + ' and ' +
        slsParams.Values[sDateTo]
    else if slsParams.Values[sDateFrom] <> '' then
      sDates := 'on or after ' + slsParams.Values[sDateFrom]
    else if slsParams.Values[sDateTo] <> '' then
      sDates := 'on or before ' + slsParams.Values[sDateTo];
    qrpQuickReport.ReportTitle := qrpQuickReport.ReportTitle + ' ' + sDates;
    if sDates <> '' then
      sSelection := sSelection + ' ' + sConnect + 'Sale Date is ' + sDates;
    SQL.Add('order by ' + slsParams.Values[sSortBy]);
    Open;
    SetSelection(Copy(sSelection, 8, Length(sSelection) - 7),  { Remove initial connector }
      slsParams.Values[sSortDesc]);
  end;
end;

{ Override method to always print summary }
procedure TqrfReport2.qrbSummaryBeforePrint(Sender: TQRCustomBand;
  var PrintBand: Boolean);
begin
  PrintBand := True;
end;

initialization
  { Tell application about this form }
  RegisterClass(TqrfReport2);
end.
