unit Copyf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, FileCtrl, StdCtrls;

type
  TForm1 = class(TForm)
    FileListBox1: TFileListBox;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    CopyBtn: TButton;
    DestEdit: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    procedure CopyBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure CopyFile(srcName, DestName: String);
{
Copies the source file to the destination
file.
}
var
  buff:        array[1..8192] of Char;
  srcFile,
  destFile:    File;
  readCount,
  writeCount:  Integer;
begin
  {Open the source file.}
  Assign(srcFile, srcName);
  Reset(srcFile, 1);
  {Open the destination file.}
  Assign(destFile, destName);
  Rewrite(destFile, 1);
  {Copy a buffer full at a time until the
   end of the file is reached or a write
   error occurs.}
  repeat
    BlockRead(srcFile, buff, SizeOf(buff), readCount);
    BlockWrite(destFile, buff, readCount, writeCount);
  until (readCount = 0) or (writeCount < readCount);
  {Close the files.}
  System.Close(srcFile);
  System.Close(destFile);
end;

procedure TForm1.CopyBtnClick(Sender: TObject);
begin
  CopyFile(FileListBox1.Filename, DestEdit.Text);
end;


end.
