unit EcAllOrd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, Grids, DBGrids, ExtCtrls, DBCtrls, StdCtrls;

type
  TAllOrdersForm = class(TForm)
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    AllOrdersSrc: TDataSource;
    CustomerLabel: TLabel;
    TotalLabel: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure AllOrdersSrcDataChange(Sender: TObject; Field: TField);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AllOrdersForm: TAllOrdersForm;

implementation

uses EcDm;

{$R *.DFM}

procedure TAllOrdersForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TAllOrdersForm.FormCreate(Sender: TObject);
begin
  with MainDm.AllOrdersCds do
  begin
    Open;
    AddIndex('OrderTotalIndex',
             'CustNo;OrderTotal',
             [], 'OrderTotal', '', 1);
    IndexName := 'OrderTotalIndex';
    First;
  end; //with
end;

procedure TAllOrdersForm.AllOrdersSrcDataChange(Sender: TObject;
  Field: TField);
begin
  with MainDm do
  begin
      CustomerLabel.Caption := 'Customer ' +
        AllOrdersCdsCustNo.AsString +
        ' Total:';
      if (VarType(AllOrdersCdsCustomerTotal.Value) >= varSingle) and
         (VarType(AllOrdersCdsCustomerTotal.Value) <= varDouble) then
        TotalLabel.Caption :=
          FormatFloat('$###,###,###.00', AllOrdersCdsCustomerTotal.Value)
      else
        TotalLabel.Caption := '';
  end; //with
end;

end.
