unit EcDm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBClient, MConnect, Db;

type
  TMainDm = class(TDataModule)
    EbConn: TDCOMConnection;
    CustomerCds: TClientDataSet;
    OrderCds: TClientDataSet;
    CustomerSrc: TDataSource;
    OrderSrc: TDataSource;
    AllOrdersCds: TClientDataSet;
    AllOrdersCdsOrderNo: TFloatField;
    AllOrdersCdsCustNo: TFloatField;
    AllOrdersCdsSaleDate: TDateTimeField;
    AllOrdersCdsShipDate: TDateTimeField;
    AllOrdersCdsItemsTotal: TCurrencyField;
    AllOrdersCdsTaxRate: TFloatField;
    AllOrdersCdsFreight: TCurrencyField;
    AllOrdersCdsOrderTotal: TCurrencyField;
    AllOrdersCdsCustomerTotal: TAggregateField;
    procedure CustomerCdsReconcileError(DataSet: TClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure OrderCdsReconcileError(DataSet: TClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure AllOrdersCdsCalcFields(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainDm: TMainDm;

implementation

uses RecErrF;

{$R *.DFM}

procedure TMainDm.CustomerCdsReconcileError(DataSet: TClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind;
  var Action: TReconcileAction);
begin
  Action := HandleReconcileError(DataSet, UpdateKind, E);
end;

procedure TMainDm.OrderCdsReconcileError(DataSet: TClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind;
  var Action: TReconcileAction);
begin
  Action := HandleReconcileError(DataSet, UpdateKind, E);
end;

procedure TMainDm.AllOrdersCdsCalcFields(DataSet: TDataSet);
var
  Tax:         Currency;
begin
  Tax := (AllOrdersCdsTaxRate.Value / 100.0) * AllOrdersCdsItemsTotal.Value;
  AllOrdersCdsOrderTotal.Value :=
    AllOrdersCdsItemsTotal.Value + Tax + AllOrdersCdsFreight.Value;
end;

end.
