unit Fastf;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    CreateBtn: TButton;
    ReadBtn: TButton;
    DeleteBtn: TButton;
    Label1: TLabel;
    ReadCount: TLabel;
    procedure CreateBtnClick(Sender: TObject);
    procedure ReadBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type
  TAddress = record
    name:       array[1..35] of Char;
    Addr:       array[1..35] of Char;
    City:       array[1..18] of Char;
    State:      array[1..2] of Char;
    Zip:        array[1..10] of Char;
  end;

procedure PasToArray(const str: String;
                     var arr: array of Char);
{
Copies a Pascal String to a Char array.  The
array is padded with blanks.
}
var
  i:     Word;
begin
  {Fill the array with spaces in case the
   string is shorter than the array.}
  for i := 0 to High(arr) do arr[i] := ' ';
  {Copy the string to the array.}
  for i := 1 to Length(str) do arr[i - 1] := str[i];
end;

procedure TForm1.CreateBtnClick(Sender: TObject);
const
  MaxRecs = 100;
var
  buff:         array[1..MaxRecs] of TAddress;
  addrFile:     File;
  i, count:     Integer;
begin
  AssignFile(addrFile, 'addr.dat');
  {initialize the buffer}
  FillChar(buff,SizeOf(Buff),#0);          {added by RLV on 12/29/97}
  Rewrite(addrFile, SizeOf(TAddress));
  {Put 100 records into the buffer.}
  for i := 1 to MaxRecs do
    with buff[i] do
    begin
      PasToArray('John Doe', name);
      PasToArray('123 East Main Street', addr);
      PasToArray('New York', city);
      PasToArray('NY', state);
      PasToArray('55555-5555', zip);
    end;
    {Write 100 buffers (10,000 records.}
    for i := 1 to 100 do
      BlockWrite(addrFile, buff, MaxRecs, count);
    System.Close(addrFile);
end;

procedure TForm1.ReadBtnClick(Sender: TObject);
const
  MaxRecs = 500;
type
  Tbuff =       array[1..MaxRecs] of TAddress;
var
  buff:         ^Tbuff;
  addrFile:     File;
  total,
  count:        Integer;
begin
  try
    New(buff);
  except
    on EOutOfMemory do Exit;
  end;
  try
    AssignFile(addrFile, 'addr.dat');
    Reset(addrFile, SizeOf(TAddress));
    {Read the file MaxRecs records at a time.}
    total := 0;
    repeat
      count := 0;
      BlockRead(addrFile, buff^, MaxRecs, count);
      total := total + count;
    until count = 0;
    System.Close(addrFile);
    ReadCount.Caption := IntToStr(total);
  finally
    Dispose(buff);
  end;
end;

procedure TForm1.DeleteBtnClick(Sender: TObject);
begin
  DeleteFile('addr.dat');
end;

end.
