unit FlatMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, ExtCtrls, Grids, DBGrids, Menus, Db;

type
  TMainForm = class(TForm)
    LastNameEdit: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    FirstNameEdit: TDBEdit;
    Label3: TLabel;
    InitialEdit: TDBEdit;
    Address1Edit: TDBEdit;
    Label4: TLabel;
    Address2Edit: TDBEdit;
    Label5: TLabel;
    CityEdit: TDBEdit;
    Label6: TLabel;
    Label7: TLabel;
    StateEdit: TDBEdit;
    Label8: TLabel;
    ZipEdit: TDBEdit;
    Label9: TLabel;
    SuffixEdit: TDBEdit;
    Label10: TLabel;
    HonorificEdit: TDBEdit;
    Navigator: TDBNavigator;
    NumberGrid: TDBGrid;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SaveChanges1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    UndoCurrentRecord1: TMenuItem;
    UndoAllChanges1: TMenuItem;
    DBText1: TDBText;
    Label11: TLabel;
    TotalLabel: TLabel;
    procedure NumberGridEnter(Sender: TObject);
    procedure NumberGridExit(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure SaveChanges1Click(Sender: TObject);
    procedure UndoCurrentRecord1Click(Sender: TObject);
    procedure UndoAllChanges1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses FlatDm;

{$R *.DFM}

procedure TMainForm.NumberGridEnter(Sender: TObject);
begin
  Navigator.DataSource := MainDm.NumberSrc;
end;

procedure TMainForm.NumberGridExit(Sender: TObject);
begin
  Navigator.DataSource := MainDm.PersonSrc;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.SaveChanges1Click(Sender: TObject);
begin
  {If there are unposted records post them.}
  if MainDm.PersonCds.State in [dsEdit, dsInsert] then
    MainDm.PersonCds.Post;
  if MainDm.NumberCds.State in [dsEdit, dsInsert] then
    MainDm.NumberCds.Post;
  {Merge the changes and save the data.}
  with MainDm.PersonCds do
  begin
    MergeChangeLog;
    SaveToFile('phone.ffd');
  end;
  {Update the number of saved records.}
  TotalLabel.Caption :=
    IntToStr(MainDm.PersonCds.Aggregates.Find('TotalRecords').Value) +
    ' saved records';
end;

procedure TMainForm.UndoCurrentRecord1Click(Sender: TObject);
begin
  MainDm.PersonCds.RevertRecord;
end;

procedure TMainForm.UndoAllChanges1Click(Sender: TObject);
begin
  MainDm.PersonCds.CancelUpdates;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  TotalLabel.Caption :=
    IntToStr(MainDm.PersonCds.Aggregates.Find('TotalRecords').Value) +
    ' saved records';
end;

end.
