unit LtDm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBClient, DBTables, Provider, BdeProv;

type
  TMainDm = class(TDataModule)
    Database1: TDatabase;
    CustomerTable: TTable;
    CustomerCds: TClientDataSet;
    CustomerSrc: TDataSource;
    CustomerProv: TProvider;
    OrderTable: TTable;
    OrderProv: TProvider;
    OrderCds: TClientDataSet;
    OrderSrc: TDataSource;
    CDeltaCds: TClientDataSet;
    ODeltaCds: TClientDataSet;
    CDeltaSrc: TDataSource;
    ODeltaSrc: TDataSource;
    CDeltaCdsCustNo: TFloatField;
    CDeltaCdsCompany: TStringField;
    CDeltaCdsAddr1: TStringField;
    CDeltaCdsAddr2: TStringField;
    CDeltaCdsCity: TStringField;
    CDeltaCdsState: TStringField;
    CDeltaCdsZip: TStringField;
    CDeltaCdsCountry: TStringField;
    CDeltaCdsPhone: TStringField;
    CDeltaCdsFAX: TStringField;
    CDeltaCdsTaxRate: TFloatField;
    CDeltaCdsContact: TStringField;
    CDeltaCdsLastInvoiceDate: TDateTimeField;
    CDeltaCdsStatus: TStringField;
    ODeltaCdsOrderNo: TFloatField;
    ODeltaCdsCustNo: TFloatField;
    ODeltaCdsSaleDate: TDateTimeField;
    ODeltaCdsShipDate: TDateTimeField;
    ODeltaCdsEmpNo: TIntegerField;
    ODeltaCdsShipToContact: TStringField;
    ODeltaCdsShipToAddr1: TStringField;
    ODeltaCdsShipToAddr2: TStringField;
    ODeltaCdsShipToCity: TStringField;
    ODeltaCdsShipToState: TStringField;
    ODeltaCdsShipToZip: TStringField;
    ODeltaCdsShipToCountry: TStringField;
    ODeltaCdsShipToPhone: TStringField;
    ODeltaCdsShipVIA: TStringField;
    ODeltaCdsPO: TStringField;
    ODeltaCdsTerms: TStringField;
    ODeltaCdsPaymentMethod: TStringField;
    ODeltaCdsItemsTotal: TCurrencyField;
    ODeltaCdsTaxRate: TFloatField;
    ODeltaCdsFreight: TCurrencyField;
    ODeltaCdsAmountPaid: TCurrencyField;
    ODeltaCdsStatus: TStringField;
    procedure CustomerCdsReconcileError(DataSet: TClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure OrderCdsReconcileError(DataSet: TClientDataSet;
      E: EReconcileError; UpdateKind: TUpdateKind;
      var Action: TReconcileAction);
    procedure CDeltaCdsCalcFields(DataSet: TDataSet);
    procedure ODeltaCdsCalcFields(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainDm: TMainDm;

implementation

uses RecErrF;

{$R *.DFM}

procedure TMainDm.CustomerCdsReconcileError(DataSet: TClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind;
  var Action: TReconcileAction);
begin
  Action := HandleReconcileError(DataSet, UpdateKind, E);
end;

procedure TMainDm.OrderCdsReconcileError(DataSet: TClientDataSet;
  E: EReconcileError; UpdateKind: TUpdateKind;
  var Action: TReconcileAction);
begin
  Action := HandleReconcileError(DataSet, UpdateKind, E);
end;

procedure TMainDm.CDeltaCdsCalcFields(DataSet: TDataSet);
begin
  case DataSet.UpdateStatus of
    usModified:   CDeltaCdsStatus.AsString := 'Modified';
    usUnModified: CDeltaCdsStatus.AsString := 'Unmodified';
    usInserted:   CDeltaCdsStatus.AsString := 'Inserted';
    UsDeleted:    CDeltaCdsStatus.AsString := 'Deleted';
  end; //case
end;

procedure TMainDm.ODeltaCdsCalcFields(DataSet: TDataSet);
begin
  case DataSet.UpdateStatus of
    usModified:   ODeltaCdsStatus.AsString := 'Modified';
    usUnModified: ODeltaCdsStatus.AsString := 'Unmodified';
    usInserted:   ODeltaCdsStatus.AsString := 'Inserted';
    UsDeleted:    ODeltaCdsStatus.AsString := 'Deleted';
  end; //case
end;

end.
