unit LtMainF;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, StdCtrls, ExtCtrls, DBCtrls, Db, Menus;

type
  TMainForm = class(TForm)
    DBNavigator1: TDBNavigator;
    CommitBtn: TButton;
    DBGrid1: TDBGrid;
    RollbackBtn: TButton;
    DBNavigator2: TDBNavigator;
    DBGrid2: TDBGrid;
    MainMenu1: TMainMenu;
    View1: TMenuItem;
    Delta1: TMenuItem;
    procedure CommitBtnClick(Sender: TObject);
    procedure RollbackBtnClick(Sender: TObject);
    procedure Delta1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses LtDm, LtDeltaF;

{$R *.DFM}

procedure TMainForm.CommitBtnClick(Sender: TObject);
begin
  with MainDm do
  begin
    if CustomerCds.State in [dsEdit, dsInsert] then
      CustomerCds.Post;
    if CustomerCds.ChangeCount > 0 then
    begin
      CustomerCds.ApplyUpdates(-1);
      CustomerCds.Refresh;
    end; //if

    if OrderCds.State in [dsEdit, dsInsert] then
      OrderCds.Post;
    if OrderCds.ChangeCount > 0 then
    begin
      OrderCds.ApplyUpdates(-1);
      OrderCds.Refresh;
    end; //if
  end; //with
end;

procedure TMainForm.RollbackBtnClick(Sender: TObject);
begin
  MainDm.CustomerCds.CancelUpdates;
  MainDm.OrderCds.CancelUpdates;
end;

procedure TMainForm.Delta1Click(Sender: TObject);
begin
  DeltaForm := TDeltaForm.Create(Self);
  try
    with MainDm do
    begin
      if CustomerCds.ChangeCount > 0 then
      begin
        CDeltaCds.Close;
        CDeltaCds.Data := CustomerCds.Delta;
        CDeltaCds.Open;
      end; //if

      if OrderCds.ChangeCount >0 then
      begin
        ODeltaCds.Close;
        ODeltaCds.Data := OrderCds.Delta;
        ODeltaCds.Open;
      end; //if
    end;
    DeltaForm.ShowModal;
  finally
    DeltaForm.Free;
  end; //try
end;

end.
