unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AMWinEnv, StdCtrls, AMReg;

type
  TForm1 = class(TForm)
    AMWE: TAMWinEnv;
    GroupBox1: TGroupBox;
    cbSystemKey: TCheckBox;
    cbScreenSaver: TCheckBox;
    GroupBox2: TGroupBox;
    cbTaskbarButton: TCheckBox;
    cbTaskListItem: TCheckBox;
    Button1: TButton;
    GroupBox3: TGroupBox;
    cbHTrayBar: TCheckBox;
    cbHTrayNotify: TCheckBox;
    cbHStartButton: TCheckBox;
    cbHAppSwitchBar: TCheckBox;
    cbHTrayClock: TCheckBox;
    cbHDesktopIcons: TCheckBox;
    GroupBox4: TGroupBox;
    cbDTrayBar: TCheckBox;
    cbDStartButton: TCheckBox;
    cbDAppSwitchBar: TCheckBox;
    cbDDesktopIcons: TCheckBox;
    GroupBox5: TGroupBox;
    cbDisableMultiInstance: TCheckBox;
    cbAutoRunApp: TCheckBox;
    cbKeepAfterClose: TCheckBox;
    cbDisableShutDown: TCheckBox;
    AMR: TAMReg;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure cbTaskbarButtonClick(Sender: TObject);
    procedure cbHTrayBarClick(Sender: TObject);
    procedure cbSystemKeyClick(Sender: TObject);
    procedure cbDTrayBarClick(Sender: TObject);
    procedure cbDisableMultiInstanceClick(Sender: TObject);
    procedure AMWESecondInstance(Sender: TObject);
    procedure AMWEStartScrnSaver(Sender: TObject);
    procedure AMWETryShutDown(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateCheckBoxes;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.UpdateCheckBoxes;
begin
  with AMWE do
  begin
    cbSystemKey.Checked := DisableSysKey;
    cbScreenSaver.Checked := DisableScrnSaver;
    cbTaskbarButton.Checked := (hoTaskbarButton in AppHideOption);
    cbTaskListItem.Checked := (hoTaskListItem in AppHideOption);
    cbHTrayBar.Checked := (hoTrayBar in HideOption);
    cbHTrayNotify.Checked := (hoTrayNotify in HideOption);
    cbHStartButton.Checked := (hoStartButton in HideOption);
    cbHAppSwitchBar.Checked := (hoAppSwitchBar in HideOption);
    cbHTrayClock.Checked := (hoTrayClock in HideOption);
    cbHDesktopIcons.Checked := (hoDesktopIcons in HideOption);
    cbDTrayBar.Checked := (hoTrayBar in DisableOption);
    cbDStartButton.Checked := (hoStartButton in DisableOption);
    cbDAppSwitchBar.Checked := (hoAppSwitchBar in DisableOption);
    cbDDesktopIcons.Checked := (hoDesktopIcons in DisableOption);
    cbDisableMultiInstance.Checked := DisableMultiInstance;
    cbAutoRunApp.Checked := AppRegistered;
    cbKeepAfterClose.Checked := KeepAfterClose;
    cbDisableShutDown.Checked := DisableShutDown;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.cbTaskbarButtonClick(Sender: TObject);
begin
  with AMWE do
    if TCheckBox(Sender).Checked then
    case TCheckBox(Sender).Tag of
      0: AppHideOption := AppHideOption + [hoTaskbarButton];
      1: AppHideOption := AppHideOption + [hoTasklistItem];
    end
    else
    case TCheckBox(Sender).Tag of
      0: AppHideOption := AppHideOption - [hoTaskbarButton];
      1: AppHideOption := AppHideOption - [hoTasklistItem];
    end;
end;

procedure TForm1.cbHTrayBarClick(Sender: TObject);
begin
  with AMWE do
    if TCheckBox(Sender).Checked then
    case TCheckBox(Sender).Tag of
      0: HideOption := HideOption + [hoTrayBar];
      1: HideOption := HideOption + [hoTrayNotify];
      2: HideOption := HideOption + [hoStartButton];
      3: HideOption := HideOption + [hoAppSwitchBar];
      4: HideOption := HideOption + [hoTrayClock];
      5: HideOption := HideOption + [hoDesktopIcons];
    end
    else
    case TCheckBox(Sender).Tag of
      0: HideOption := HideOption - [hoTrayBar];
      1: HideOption := HideOption - [hoTrayNotify];
      2: HideOption := HideOption - [hoStartButton];
      3: HideOption := HideOption - [hoAppSwitchBar];
      4: HideOption := HideOption - [hoTrayClock];
      5: HideOption := HideOption - [hoDesktopIcons];
    end;
end;

procedure TForm1.cbSystemKeyClick(Sender: TObject);
begin
  with AMWE do
    case TCheckBox(Sender).Tag of
      0 : DisableSysKey := TCheckBox(Sender).Checked;
      1 : DisableScrnSaver := TCheckBox(Sender).Checked;
    end;
end;

procedure TForm1.cbDTrayBarClick(Sender: TObject);
begin
  with AMWE do
    if TCheckBox(Sender).Checked then
    case TCheckBox(Sender).Tag of
      0: DisableOption := DisableOption + [hoTrayBar];
      2: DisableOption := DisableOption + [hoStartButton];
      3: DisableOption := DisableOption + [hoAppSwitchBar];
      5: DisableOption := DisableOption + [hoDesktopIcons];
    end
    else
    case TCheckBox(Sender).Tag of
      0: DisableOption := DisableOption - [hoTrayBar];
      2: DisableOption := DisableOption - [hoStartButton];
      3: DisableOption := DisableOption - [hoAppSwitchBar];
      5: DisableOption := DisableOption - [hoDesktopIcons];
    end;
end;

procedure TForm1.cbDisableMultiInstanceClick(Sender: TObject);
begin
  with AMWE do
    case TCheckBox(Sender).Tag of
      0: DisableMultiInstance := TCheckBox(Sender).Checked;
      1: if TCheckBox(Sender).Checked then
           AMWE.Register
         else
           AMWE.Unregister;
      2: KeepAfterClose := TCheckBox(Sender).Checked;
      3: DisableShutDown := TCheckBox(Sender).Checked;
    end;
end;

procedure TForm1.AMWESecondInstance(Sender: TObject);
begin
  MessageBeep(0);
  MessageDlg('You cannot start this application more than once!', mtWarning, [mbOk], 0);
end;

procedure TForm1.AMWEStartScrnSaver(Sender: TObject);
begin
  MessageBeep(0);
  MessageDlg('Screen-saver not started!', mtWarning, [mbOk], 0);
end;

procedure TForm1.AMWETryShutDown(Sender: TObject);
begin
  MessageBeep(0);
  MessageDlg('You may not shutdown Windows or this application!', mtWarning, [mbOk], 0);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  AMWE.SaveSettings;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  AMWE.LoadSettings;
  UpdateCheckboxes;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  UpdateCheckboxes;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  AMWE.LoadSettings;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  AMWE.SaveSettings;
end;

end.
